SystemOrganization addCategory: #'Aeropuerto-Logic'!
SystemOrganization addCategory: #'Aeropuerto-AsientoDeAvion-Test'!
SystemOrganization addCategory: #'Aeropuerto-Persona-Test'!
SystemOrganization addCategory: #'Aeropuerto-SistemaDeReservas-Test'!
SystemOrganization addCategory: #'Aeropuerto-Vuelo-Test'!
SystemOrganization addCategory: #'Aeropuerto-Pasajes-Test'!
SystemOrganization addCategory: #'Aeropuerto-Jet-Test'!
SystemOrganization addCategory: #'Aeropuerto-Comercial-Test'!

TestCase subclass: #ComercialTest
	instanceVariableNames: 'comercial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Comercial-Test'!

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 09:43'!
setUp 
	comercial := Avion newNombre: 'Avion-Comercial' tipo: TipoComercial new.
	! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:32'!
testCantidadDeAsientos
	self assert: ( comercial cantidadDeAsientos = 200)! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:31'!
testNombre 
	self assert: (comercial nombre = 'Avion-Comercial')! !

!ComercialTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:32'!
testVelocidadPromedio 
	self assert: ( comercial velocidadPromedio = 800 )! !

TestCase subclass: #JetTest
	instanceVariableNames: 'jet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Jet-Test'!

!JetTest methodsFor: 'running' stamp: 'LeandroGomez 6/23/2012 09:43'!
setUp 
	jet := Avion newNombre: 'Avion-Jet' tipo: TipoJet new.! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:28'!
testCantidadDeAsientos
	self assert: (jet cantidadDeAsientos = 60)! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:31'!
testNombre
	self assert: (jet nombre = 'Avion-Jet')! !

!JetTest methodsFor: 'tests' stamp: 'LeandroGomez 6/10/2012 14:28'!
testVelocidadPromedio
	self assert: (jet velocidadPromedio = 1200)! !

TestCase subclass: #PasajeTest
	instanceVariableNames: 'business economica primera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Pasajes-Test'!

!PasajeTest methodsFor: 'running' stamp: 'LeandroGomez 6/23/2012 09:44'!
setUp 
	| jet persona vuelo despegue|
	despegue := Date today addMonths: 4.
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	jet := Avion newNombre: 'Avion-Jet' tipo: TipoJet new.
	vuelo := Internacional newOrigen: 'Buenos Aires' destino: 'So Paulo' avion: jet fechaDeSalida: despegue.
	primera := Pasaje newPersona: persona vuelo: vuelo nroAsiento: 37 tipoPasaje: Primera new.
	business := Pasaje newPersona: persona vuelo: vuelo nroAsiento: 27tipoPasaje: Business  new.
	economica := Pasaje newPersona: persona vuelo: vuelo nroAsiento: 17tipoPasaje: Economica new.! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 11:49'!
testBusinessCostoPorClase
	self assert: (business costoPorClase = 0.75)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 11:48'!
testEconomicaCostoPorClase
	self assert: (economica costoPorClase = 0.5)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/16/2012 10:59'!
testPrimeraCosto
	| sistema |
	sistema := SistemaDeReservas newDefaultTest.
	self assert: ((primera costoPara: sistema) = 2000)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/17/2012 13:21'!
testPrimeraCostoALaFecha
	| fecha sistema|
	sistema := SistemaDeReservas newDefaultTest.
	fecha := Date today addMonths: 2.
	self assert: ((primera costoALaFecha: fecha para: sistema sistemaDeDescuento ) = 571)! !

!PasajeTest methodsFor: 'test' stamp: 'LeandroGomez 6/11/2012 12:09'!
testPrimeraCostoPorClase
	self assert: (primera costoPorClase = 1)! !

TestCase subclass: #PersonaTest
	instanceVariableNames: 'persona'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Persona-Test'!

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 12:21'!
setUp 
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:41'!
testApellido
	self assert: (persona fnacimiento = '5 may 1992' asDate)! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:41'!
testFechaNacimiento
	self assert: (persona apellido = 'Gomez')! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:42'!
testNacionalidad
	self assert: ( persona nacionalidad = 'Argentino' )! !

!PersonaTest methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:40'!
testNombre
	self assert: (persona nombre = 'Leandro')! !

TestCase subclass: #SistemaDeReservasTest
	instanceVariableNames: 'sistemaDeReservas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-SistemaDeReservas-Test'!

!SistemaDeReservasTest methodsFor: 'running' stamp: 'LeandroGomez 6/23/2012 09:45'!
setUp 
	| lean diego alejandro jet1 jet2 com1 com2 vue1 vue2 vue3|
	sistemaDeReservas := SistemaDeReservas newDefaultTest.
	
	" Personas "
	lean := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' asDate nacionalidad: 	'Argentino'.
	diego := Persona newNombre: 'Matias' apellido: 'Gonzalez' fnacimiento: '6 july 1990' asDate nacionalidad: 	'Argentino'.
	alejandro := Persona newNombre: 'Alejandro' apellido: 'Perez' fnacimiento: '16 april 1980' nacionalidad: 	'Brasileo'.
	sistemaDeReservas personas add: lean; add: diego; add: alejandro.

	"Aviones"

	jet1:= Avion newNombre: 'Jet-1' tipo: TipoJet new.
	jet2 := Avion newNombre: 'Jet-2'tipo: TipoJet new.
	com1 := Avion newNombre: 'Comercial-1'tipo: TipoComercial  new.
	com2 := Avion newNombre: 'Comercial-2'tipo: TipoComercial  new.
	sistemaDeReservas aviones add: jet1; add: jet2; add: com1; add: com2.

	"Vuelos"
	vue1 := Internacional newOrigen: 'Buenos Aires' destino: 'So Paulo' 
				avion: (sistemaDeReservas aviones detect: [:each | 	each nombre = 'Jet-1']) 
				fechaDeSalida: '16 november 2012' asDate.
	vue2 := Internacional  newOrigen: 'So Paulo' destino: 'Fortaleza' 
				avion: (sistemaDeReservas aviones detect: [:each | 	each nombre = 'Jet-2']) 
				fechaDeSalida: '17 november 2012' asDate.
	vue3 := Transbordo newOrigen: 'BuenosAires' destino: 'So Paulo' 
				avion: (sistemaDeReservas aviones detect: [:each | 	each nombre = 'Comercial-1'])  
				fechaDeSalida: '18 november 2012' asDate siguienteVuelo: vue2.
	sistemaDeReservas vuelos add: vue1; add: vue2; add: vue3.
	sistemaDeReservas expender: Business persona: lean vuelo: vue3 asiento: 37 .
	sistemaDeReservas expender: Primera  persona: diego vuelo: vue1 asiento: 27.


! !

TestCase subclass: #TestAsientoDeAvion
	instanceVariableNames: 'libre reservado confirmado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-AsientoDeAvion-Test'!

!TestAsientoDeAvion methodsFor: 'running' stamp: 'LeandroGomez 6/11/2012 20:05'!
setUp 
	|persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
							fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
							
	reservado := AsientoDeAvion newNumero: 73.
	reservado asignar: persona.
	confirmado := AsientoDeAvion newNumero: 37.
	confirmado asignar: persona; confirmar.
	libre := AsientoDeAvion newNumero: 28.! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:14'!
testAsientoConfirmadoEstado
	self assert: (confirmado estaConfirmado).! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:14'!
testAsientoConfirmadoLiberar
	confirmado liberar.
	self assert: ( confirmado estaLibre)! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:15'!
testAsientoConfirmadoNumero
	self assert: ( confirmado numero = 37 ).! !

!TestAsientoDeAvion methodsFor: 'testConfirmado' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoConfirmadoPersona
	self assert: ( confirmado persona nombre = 'Leandro' ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/11/2012 20:06'!
testAsientoLibreAsignarPersona
	|persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
						fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
	libre asignar: persona.
	self assert: ( libre esPasajero: persona).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoLibreEstado
	self assert: (libre estaLibre).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:06'!
testAsientoLibreNumero
	self assert: ( libre numero = 28 ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoLibrePersona
	self assert: ( libre persona  = nil ).! !

!TestAsientoDeAvion methodsFor: 'testLibre' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoLibreReservar
	libre reservar.
	self assert: ( libre estaReservado )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoConfirmar
	reservado confirmar.
	self assert: ( reservado estaConfirmado )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoEstado
	self assert: (reservado estaReservado).! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:16'!
testAsientoReservadoLiberar
	reservado liberar.
	self assert: ( reservado estaLibre  )! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:05'!
testAsientoReservadoNumero
	self assert: ( reservado numero= 73 ).! !

!TestAsientoDeAvion methodsFor: 'testReservado' stamp: 'LeandroGomez 6/10/2012 14:04'!
testAsientoReservadoPersona
	self assert: ( reservado persona nombre = 'Leandro' ).! !

TestCase subclass: #VueloTest
	instanceVariableNames: 'internacional transbordo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Vuelo-Test'!

!VueloTest methodsFor: 'running' stamp: 'LeandroGomez 6/23/2012 09:45'!
setUp 
	| avion avion2|
	avion := Avion newNombre: 'Avion-Jet' tipo: TipoJet new.

	internacional := Internacional newOrigen: 'So Paulo' destino: 'Fortaleza' avion: avion 
						fechaDeSalida: ((Date today) addMonths: 3).
						
	transbordo := Transbordo newOrigen: 'Buenos Aires' destino: 'So Paulo' avion: avion 
						fechaDeSalida: ((Date today) addMonths: 4) siguienteVuelo: internacional.
	
						! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:42'!
testTransbordoDestino
	self assert: (transbordo destino = 'So Paulo')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 00:52'!
testTransbordoDestinoFinal
	self assert: (transbordo destinoFinal = 'Fortaleza')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 00:52'!
testTransbordoDistanciaPromedio
	self assert: (transbordo distanciaPromedio = 4000)! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 00:56'!
testTransbordoDuracion
	self assert: ( transbordo duracion = 5)! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:42'!
testTransbordoOrigen
	self assert: (transbordo origen = 'Buenos Aires')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:41'!
testTransbordoSiguienteVueloDestino
	self assert: (transbordo siguienteVuelo destino = 'Fortaleza')! !

!VueloTest methodsFor: 'transbordoTest' stamp: 'LeandroGomez 6/11/2012 11:43'!
testTransbordoSiguienteVueloOrigen
	self assert: (transbordo siguienteVuelo origen = 'So Paulo')! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:06'!
testinternacionalAsignarPersonaAAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1992' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: (internacional esPasajero: persona asiento: 37)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:28'!
testinternacionalCancelar
	internacional cancelar.
	self assert: (internacional estaCancelado)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:45'!
testinternacionalCantidadDeAsentos
	self assert: (internacional cantidadDeAsientos = 60)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalConfirmarAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	internacional confirmar: 37.
	self assert: (internacional estaConfirmado:  37)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/10/2012 23:58'!
testinternacionalDestinoFinal
	self assert: (internacional destinoFinal = 'Fortaleza')! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:31'!
testinternacionalDistanciaPromedio
	self assert: (internacional distanciaPromedio = 2000) ! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:47'!
testinternacionalDuracion
	self assert: ( internacional duracion = (5/3) )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 00:28'!
testinternacionalEsperaDespegue
	self assert: (internacional esperaDespegue)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 12:16'!
testinternacionalFechaSalida
	self assert: (internacional fechaSalida = ((Date today) addMonths: 3) )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalLiberarAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: (internacional estaReservado: 37).
	internacional liberar: 37.
	self assert: (internacional estaLibre: 37)! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/10/2012 23:59'!
testinternacionalOrigen
	self assert: (internacional origen = 'So Paulo' )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalPasajeroDelAsiento
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: ((internacional pasajeroDelAsiento: 37) == persona )! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:07'!
testinternacionalReprogramarDespegue
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 3) ).
	internacional reprogramar: ((Date today) addMonths: 4) .
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 4) ).! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/23/2012 09:46'!
testinternacionalReprogramarDespegueYAvion
	| avion | 
	avion := Avion newNombre: 'Avion-Jet' tipo: TipoJet new.
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 3) ).
	internacional reprogramar: ((Date today) addMonths: 5)  avion: avion.
	self assert: ( internacional fechaSalida = ((Date today) addMonths: 5)  asDate ).
	self assert: ( internacional avion == avion ).! !

!VueloTest methodsFor: 'internacionalTest' stamp: 'LeandroGomez 6/11/2012 20:08'!
testinternacionalViajaPersona
	| persona |
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' 
					fnacimiento: '5 may 1922' asDate nacionalidad: 'Argentino'.
					
	internacional asignar: persona asiento: 37.
	self assert: ( internacional viaja: persona )! !

Object subclass: #AsientoDeAvion
	instanceVariableNames: 'estado persona numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:40'!
new
	self error: 'Un asiento de avion necesita un numero, use "newNumero: " '! !

!AsientoDeAvion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/11/2012 23:01'!
newNumero: unNumero
	|asiento|
	asiento := super new.
	asiento numero: unNumero.
	^asiento.! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroGomez 6/11/2012 18:10'!
< unAsiento
	^(self numero < unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroGomez 6/11/2012 18:09'!
<= unAsiento
	^(self numero <= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
= unAsiento
	^(self numero = unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:22'!
> unAsiento
	^(self numero > unAsiento numero).! !

!AsientoDeAvion methodsFor: 'arithmetic' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:23'!
>= unAsiento
	^(self numero >= unAsiento numero).! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:02'!
asignar: unaPersona
	" Se asigna una Persona a un asiento "
	((self estaReservado) | (self estaConfirmado))
		ifTrue: [ self error: 'El asiento ya esta Reservado/Confirmado' ]
		ifFalse: [ 
				self reservar.
				self persona: unaPersona.
			 ]
! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 10:59'!
confirmar
	self estado: 'Confirmado'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:03'!
esPasajero: unaPersona
	^self persona == unaPersona.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaConfirmado
	^self estado = 'Confirmado'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaLibre
	^self estado = 'Libre'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/30/2012 08:43'!
estaOcupado
	^( self estaConfirmado | self estaReservado )! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:01'!
estaReservado
	^self estado = 'Reservado'.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado
	^ estado! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
estado: anObject
	estado := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:25'!
initialize 
	self estado: 'Libre'.! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:02'!
liberar
	self persona: nil.
	self estado: 'Libre'.! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero
	^ numero! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 11:17'!
numero: anObject
	numero := anObject! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona
	^ persona! !

!AsientoDeAvion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
persona: anObject
	persona := anObject! !

!AsientoDeAvion methodsFor: 'printing' stamp: 'LeandroGomez 6/9/2012 10:56'!
printOn: aStream
	(self estado = 'Libre')
		ifTrue: [ aStream nextPutAll: 'Asiento numero ', self numero asString , ' libre.']
		ifFalse: [
			
			aStream nextPutAll: 'Asiento numero ', self numero asString ,
								' de ' , self persona nombre, ' ' ,self estado
				].
	! !

!AsientoDeAvion methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 11:00'!
reservar
	self estado: 'Reservado'.! !

Object subclass: #Avion
	instanceVariableNames: 'nombre tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/8/2012 13:41'!
new
	self error: 'Un avion necesita un nombre , use "newNombre: " '! !

!Avion class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/23/2012 09:42'!
newNombre: unNombre tipo: unTipo
	|avion|
	avion := super new.
	avion nombre: unNombre.
	avion tipo: unTipo.
	^avion! !

!Avion methodsFor: 'operations' stamp: 'LeandroGomez 6/23/2012 11:02'!
cantidadDeAsientos 
	^self tipo cantidadDeAsientos! !

!Avion methodsFor: 'escritura' stamp: 'LeandroGomez 6/28/2012 11:15'!
escribirEnDiscoEnPath: unPath
	| aStream |
	aStream := FileStream fileNamed: unPath , '\aviones.txt'.
	aStream setToEnd.
	aStream nextPut: $<;
			 nextPutAll: self nombre;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self tipo printString;
			 nextPut: $>;
			 nextPut: Character cr ;
			 close.
			 ! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre
	^ nombre! !

!Avion methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:11'!
nombre: anObject
	nombre := anObject! !

!Avion methodsFor: 'printing' stamp: 'LeandroGomez 6/30/2012 08:38'!
printOn: aStream
	aStream nextPutAll: 'Avion ';
	   		 nextPutAll: self nombre;
			 nextPutAll: ' de tipo ';
			 nextPutAll: self tipo printString.! !

!Avion methodsFor: 'accessing' stamp: 'LeandroGomez 6/23/2012 09:42'!
tipo
	^ tipo! !

!Avion methodsFor: 'accessing' stamp: 'LeandroGomez 6/23/2012 09:42'!
tipo: anObject
	tipo := anObject! !

!Avion methodsFor: 'operations' stamp: 'LeandroGomez 6/23/2012 11:02'!
velocidadPromedio
	^self tipo velocidadPromedio.! !

Object subclass: #Pasaje
	instanceVariableNames: 'vuelo persona fReserva nroAsiento tipoPasaje'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Pasaje class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 10:23'!
newPersona: unaPersona vuelo: unVuelo nroAsiento: nroAsiento tipoPasaje: unTipo
	|pasaje|
	pasaje := super new.
	pasaje vuelo: unVuelo.
	pasaje persona: unaPersona.
	pasaje fReserva: Date today.
	pasaje nroAsiento: nroAsiento.
	pasaje tipoPasaje: unTipo.
	^pasaje.! !

!Pasaje methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:11'!
< otroPasaje
	^self fReserva < otroPasaje fReserva! !

!Pasaje methodsFor: 'comparing' stamp: 'LeandroGomez 6/12/2012 15:07'!
<= otroPasaje
	^self fReserva <= otroPasaje fReserva! !

!Pasaje methodsFor: 'private' stamp: 'LeandroGomez 6/11/2012 12:08'!
coeficientePorFecha: unaFecha
	|dias coef coefAux|
	dias := (unaFecha - Date today) days.
	coef := 1.
	coefAux :=1.
	[ dias > (30*coefAux) ] whileTrue: [coef := coef + 0.25. coef := coef +1. dias := dias - (30*coefAux)].
	^coef.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/23/2012 11:47'!
costoALaFecha: unaFecha para: unSistema
	"Devuelve el costo del pasaje , dependiendo del la fecha y del sistema de descuentos, mientras mas lejos de la fecha de despegue, menos saldr. "
	| descuento |
	
	descuento := unSistema descuentoParaPasaje: self.
	^(descuento * ((self tipoPasaje costoPorClase)*(self vuelo distanciaPromedio) / (self coeficientePorFecha: unaFecha)) rounded)! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/17/2012 13:18'!
costoPara: unSistema
	"Devuelve el costo del pasaje a la fecha actual"
	^(self costoALaFecha: Date today para: unSistema sistemaDeDescuento ).! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/16/2012 10:36'!
costoPorClase
	^self tipoPasaje costoPorClase.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/23/2012 11:25'!
destino
	^self vuelo destinoFinal.! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 11:56'!
distancia
	^self vuelo distanciaPromedio.
	! !

!Pasaje methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 11:56'!
duracion 
	^self vuelo duracion.! !

!Pasaje methodsFor: 'writing' stamp: 'LeandroGomez 6/28/2012 12:01'!
escribirEnDiscoEnPath: unPath
	| aStream |
	aStream := FileStream fileNamed: unPath , '\pasajes.txt'.
	aStream setToEnd.
	aStream nextPut: $<;
			 nextPutAll: self vuelo origen;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self vuelo destino;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self vuelo destinoFinal;
			 nextPut: $>;
			 nextPut: $<;			
			 nextPutAll: self vuelo fechaSalida asString;
			 nextPut: $>;
			 nextPut: $<;	
			 nextPutAll: self nroAsiento asString;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self tipoPasaje printString;
			 nextPut: $>;		 
			 nextPut: Character cr.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva
	^ fReserva! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
fReserva: anObject
	fReserva := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento
	^ nroAsiento! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
nroAsiento: anObject
	nroAsiento := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona
	^ persona! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
persona: anObject
	persona := anObject! !

!Pasaje methodsFor: 'printing' stamp: 'LeandroGomez 6/16/2012 10:37'!
printOn: aStream
	"Terminar el printOn: "
	aStream nextPutAll:  '<',
						 self persona printString ,
						 '><',
						 self vuelo origen, 
						 '><', 
						 self vuelo destinoFinal, 
						 '><',
						 self nroAsiento asString,
						 '>'.! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 10:33'!
tipoPasaje
	^ tipoPasaje! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 10:33'!
tipoPasaje: anObject
	tipoPasaje := anObject! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo
	^ vuelo! !

!Pasaje methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/6/2012 00:11'!
vuelo: anObject
	vuelo := anObject! !

Object subclass: #Persona
	instanceVariableNames: 'nombre apellido fnacimiento nacionalidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Persona class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:42'!
newNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	|persona|
	persona := super new.
	persona nombre: unNombre;
			apellido: unApellido;
			fnacimiento: unaFecha asDate;
			nacionalidad: unaNacionalidad.
	^persona.! !

!Persona methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:11'!
< otraPersona
	^self fnacimiento < otraPersona fnacimiento.! !

!Persona methodsFor: 'comparing' stamp: 'LeandroGomez 6/12/2012 14:42'!
<= otraPersona
	^self fnacimiento <= otraPersona fnacimiento.! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido
	^ apellido! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
apellido: anObject
	apellido := anObject! !

!Persona methodsFor: 'writing' stamp: 'LeandroGomez 6/28/2012 11:17'!
escribirEnDiscoEnPath: unPath
	| aStream |
	aStream := FileStream fileNamed: unPath , '\personas.txt'.
	aStream setToEnd.
	aStream nextPut: $<;
			 nextPutAll: self nombre;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self apellido;
			 nextPut: $>;
			 nextPut: $<;
			 nextPutAll: self fnacimiento asString;
			 nextPut: $>;
 			 nextPut: $<;
			 nextPutAll: self nacionalidad;
			 nextPut: $>;
			 nextPut: Character cr;
			 close.! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento
	^ fnacimiento! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
fnacimiento: anObject
	fnacimiento := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad
	^ nacionalidad! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nacionalidad: anObject
	nacionalidad := anObject! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:04'!
nombre: anObject
	nombre := anObject! !

!Persona methodsFor: 'printing' stamp: 'LeandroGomez 6/12/2012 14:35'!
printOn: aStream 
	aStream nextPutAll: self nombre, ' ', self apellido ,' ', self nacionalidad.! !

Object subclass: #SistemaDeDescuento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

SistemaDeDescuento subclass: #DescuentoASaoPaulo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!DescuentoASaoPaulo methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 11:47'!
descuentoParaPasaje: unPasaje

	( unPasaje destino = 'So Paulo' )
		ifTrue: [^0.5]
		ifFalse: [^1]! !

SistemaDeDescuento subclass: #SinDescuentos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!SinDescuentos methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 11:49'!
descuentoParaPasaje: unPasaje
	^1! !

!SistemaDeDescuento methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 11:49'!
descuentoParaPasaje: unPasaje
	self subclassResponsibility.! !

Object subclass: #SistemaDeReservas
	instanceVariableNames: 'folder pasajes vuelos personas aviones sistemaDeDescuento'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

SistemaDeReservas class
	instanceVariableNames: 'uniqueInstance test'!

SistemaDeReservas class
	instanceVariableNames: 'uniqueInstance test'!

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 08:45'!
default
	^ self defaultOnFolder:  (FileDirectory default) pathName , '\BaseDeDatos-Aeropuerto'! !

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/30/2012 09:37'!
defaultOnFolder: aPath
	| sistema |
	"aPath es la carpeta donde se guardar la base de datos del programa"
	uniqueInstance := super new.
	uniqueInstance folder: aPath.
	(FileDirectory on: aPath) assureExistence.
	(FileStream forceNewFileNamed: aPath , '\aviones.txt') close.
	(FileStream forceNewFileNamed: aPath , '\vuelos-Transbordos.txt')close.
	(FileStream forceNewFileNamed: aPath , '\vuelos-Internacional.txt')close.
	(FileStream forceNewFileNamed: aPath , '\personas.txt')close.
	(FileStream forceNewFileNamed: aPath,  '\pasajes.txt')close.
	^uniqueInstance.
	! !

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 7/1/2012 12:47'!
go
	self uniqueInstance.! !

!SistemaDeReservas class methodsFor: 'instance creation' stamp: 'LeandroGomez 6/11/2012 18:06'!
new
	self error: 'Solo hay una unica instancia de esta clase'! !

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 10:57'!
newDefaultTest

	test := super new.
	^test.! !

!SistemaDeReservas class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 09:13'!
uniqueInstance 
	uniqueInstance ifNil: [ uniqueInstance := self default ].
	^uniqueInstance.! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 6/23/2012 09:53'!
agregarAvion: unNombre tipo: unTipoAvion
	| avion |
	(self existeAvionDeLlamado: unNombre)
		ifTrue: [ self error: 'Ya existe el Avion' ]
		ifFalse: [ 
			avion := Avion newNombre: unNombre tipo: unTipoAvion.
			self aviones add:  avion. 
			avion escribirEnDiscoEnPath: self folder.
				 ]! !

!SistemaDeReservas methodsFor: 'private' stamp: 'LeandroGomez 6/23/2012 11:05'!
agregarPasaje: unPasaje
	self pasajes add: unPasaje.! !

!SistemaDeReservas methodsFor: 'operacion sobre pasajero' stamp: 'LeandroGomez 6/23/2012 10:04'!
agregarPersonaNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	| persona |
	( self estaPersonaNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad)
				ifFalse: [ 	persona := Persona newNombre: unNombre apellido: unApellido 
												fnacimiento: unaFecha nacionalidad: unaNacionalidad.
							self personas add: persona. 
							persona escribirEnDiscoEnPath: self folder]! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/30/2012 08:13'!
agregarVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha 
	| vuelo |
	(self existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha )
	      ifTrue: [self error: 'Ya existe el vuelo'] 
		ifFalse: [ 
					vuelo :=(Internacional  newOrigen: unOrigen destino: unDestino 
										  avion: unAvion fechaDeSalida: unaFecha).
					self vuelos add: vuelo. 
				 	vuelo escribirEnDiscoEnPath: self folder.
				]
		
	! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/30/2012 08:13'!
agregarVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha siguienteVuelo:  unVuelo
	| vuelo |
	(self existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha siguienteVuelo: unVuelo)
	      ifTrue: [self error: 'Ya existe el vuelo'] 
		ifFalse: [ 
					vuelo :=(Transbordo  newOrigen: unOrigen destino: unDestino 
										  avion: unAvion fechaDeSalida: unaFecha siguienteVuelo: unVuelo).
					self vuelos add: vuelo. 
				 	vuelo escribirEnDiscoEnPath: self folder.
				]
		
	! !

!SistemaDeReservas methodsFor: 'private' stamp: 'LeandroGomez 6/11/2012 22:40'!
asignar: unaPersona asiento: nroAsiento vuelo: unVuelo
	unVuelo asignar: unaPersona asiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/30/2012 08:17'!
avionLlamado: unNombre
	^(self aviones detect: [:avion | avion nombre = unNombre] ifNone: [ self error: 'No existe el avion' ] )! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones
	^ aviones! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 10:39'!
aviones: anObject
	aviones := anObject! !

!SistemaDeReservas methodsFor: 'operacion sobre sistemaDeDescuento' stamp: 'LeandroGomez 6/16/2012 11:53'!
cambiarSistemaDeDescuento: unSistemaDeDescuento
	self sistemaDeDescuento: unSistemaDeDescuento.! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/17/2012 13:02'!
cancelar: vuelo
	vuelo cancelar! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 6/11/2012 22:48'!
cancelar: nroAsiento vuelo: unVuelo
	unVuelo cancelar: nroAsiento! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 6/17/2012 13:04'!
cantidadDeAsientos: unObjeto
	^unObjeto cantidadDeAsientos.
	! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 13:04'!
cargarAviones: aFullPath
	| avionesTXT char nombre tipo tipoAvion |
	avionesTXT := FileStream readOnlyFileNamed:  aFullPath.
	[avionesTXT atEnd] 
	whileFalse: [
			nombre:= ''.
			tipo := ''.
			"Cargar el nombre"
			nombre := self datosHastaTag: avionesTXT.
			"Cargar el tipo" 
			tipo := self datosHastaTag: avionesTXT.
			"Creo el avion" 
			(tipo = 'Jet')
				ifTrue: [ tipoAvion := TipoJet new ]
				ifFalse: [ tipoAvion := TipoComercial new  ].
			(self existeAvionDeLlamado: nombre)
			ifFalse: [self aviones add: (Avion newNombre: nombre tipo: tipoAvion).].
			"Ignoro los Caracteres hasta la siguiente linea"
			 avionesTXT next.
					].
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 6/30/2012 10:35'!
cargarAvionesDefault
	self cargarAviones: self folder , '\aviones.txt'.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 13:47'!
cargarPersonas: aFullPath
	| personasTXT char nombre apellido fnacimientoString nacionalidad |
	personasTXT := FileStream readOnlyFileNamed:  aFullPath.
	[personasTXT atEnd] 
	whileFalse: [
			nombre:= ''.
			apellido := ''.
			fnacimientoString := ''.
			nacionalidad := ''.
			"Cargar el nombre"
			nombre := self datosHastaTag: personasTXT.
			"Cargar el apellido"
			apellido := self datosHastaTag: personasTXT.
			"Cargar fecha nacimiento"
			fnacimientoString := self datosHastaTag: personasTXT.
			"Cargar nacinoalidad"
			nacionalidad := self datosHastaTag: personasTXT.
			"Creo la persona"
			(self estaPersonaNombre: nombre apellido: apellido 
					fnacimiento: fnacimientoString asDate nacionalidad: nacionalidad )
					ifFalse: [ self personas add: (Persona newNombre: nombre apellido: apellido 
										fnacimiento: fnacimientoString asDate nacionalidad: nacionalidad ) 
							].
			"Ignoro los Caracteres hasta la siguiente linea"
			personasTXT next
					]. personasTXT close
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 6/30/2012 11:36'!
cargarPersonasDefault
	self cargarPersonas: self folder , '\personas.txt'.
	! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 13:47'!
cargarVuelosInternacional: aFullPath
	| vuelosInterncaionTXT char origen destino destinoFinal avion fechaDespegueString estado|
	vuelosInterncaionTXT := FileStream readOnlyFileNamed:  aFullPath.
	[vuelosInterncaionTXT atEnd] 
	whileFalse: [
			origen= ''.
			destino := ''.
			avion := ''.
			fechaDespegueString := ''.
			"Cargar el origen"
			origen := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar el destino"
			destino := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar el destinoFinal"
			destinoFinal := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar avion"
			avion := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar fecha"
			fechaDespegueString := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar estado"
			estado := self datosHastaTag: vuelosInterncaionTXT.
			"Creo el Vuelo" 
			
			(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
						fechaSalida: fechaDespegueString asDate )
			ifFalse: [| vuelo | vuelo :=(Internacional newOrigen: origen destino: destino 
						avion: avion fechaDeSalida: fechaDespegueString asDate). 
					vuelo estado: estado.
					self vuelos add: vuelo.
					].
	 		
			"Ignoro los Caracteres hasta la siguiente linea"
			char := vuelosInterncaionTXT next
					]. vuelosInterncaionTXT close.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 6/30/2012 11:49'!
cargarVuelosInternacionalDefault
	self cargarVuelosInternacional: self folder , '\vuelos-Internacional.txt'.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 13:55'!
cargarVuelosTransbordo: aFullPath
	| vuelosInterncaionTXT char origen destino destinoFinal avion fechaDespegueString estado siguienteVuelo|
	vuelosInterncaionTXT := FileStream readOnlyFileNamed:  aFullPath.
	[vuelosInterncaionTXT atEnd] 
	whileFalse: [
			origen:= ''.
			destino := ''.
			destinoFinal  := ''.
			avion := ''.
			estado:=''.
			fechaDespegueString := ''.
			"Cargar el origen"
			origen := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar el destino"
			destino := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar el destinoFinal"
			destinoFinal := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar avion"
			avion := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar fecha"
			fechaDespegueString := self datosHastaTag: vuelosInterncaionTXT.
			"Cargar estado"
			estado := self datosHastaTag: vuelosInterncaionTXT.
			"Cargo siguienteVuelo "
			( vuelosInterncaionTXT peek = $<)
				ifTrue: [siguienteVuelo := self obtenerSiguienteVuelo: vuelosInterncaionTXT. 
						(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
									fechaSalida: fechaDespegueString asDate )
						ifFalse: [| vuelo | vuelo :=(Transbordo  newOrigen: origen destino: destino 
									avion: (self avionLlamado: avion) 
										fechaDeSalida: fechaDespegueString asDate 
											siguienteVuelo: siguienteVuelo  ). 
						vuelo estado: estado.
						self vuelos add: vuelo.
								].
						
					]
				ifFalse: [(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
						fechaSalida: fechaDespegueString asDate )
						ifFalse: [| vuelo | vuelo :=(Internacional newOrigen: origen destino: destino 
						avion: (self avionLlamado: avion) fechaDeSalida: fechaDespegueString asDate). 
						vuelo estado: estado.
						self vuelos add: vuelo.
								].
						].
			"Ignoro los Caracteres hasta la siguiente linea"
			char := vuelosInterncaionTXT next
					]. vuelosInterncaionTXT close.
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 00:20'!
cargarVuelosTransbordoDefault
	self cargarVuelosTransbordo: self folder ,  '\vuelos-Transbordos.txt'.
		! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 6/11/2012 22:41'!
confirmar: nroAsiento vuelo: unVuelo
	unVuelo confirmar: nroAsiento! !

!SistemaDeReservas methodsFor: 'operacion sobre pasaje' stamp: 'LeandroGomez 6/23/2012 08:50'!
costo: unVuelo aLaFecha: unaFecha tipo: unTipo
	"Costo del pasaje a la fecha 'unaFecha' "
	"La persona es una persona default, con datos aleatorios"
	 | persona|
	persona := Persona newNombre: 'Leandro' apellido: 'Gomez' fnacimiento: '5 may 1992' nacionalidad: 'Argentino'.
	^(Pasaje newPersona: persona vuelo: unVuelo nroAsiento: 1 tipoPasaje: unTipo) costoALaFecha: unaFecha para: self sistemaDeDescuento ! !

!SistemaDeReservas methodsFor: 'operacion sobre pasaje' stamp: 'LeandroGomez 6/23/2012 08:50'!
costo: unVuelo tipo: unTipo
	"Costo del pasaje a la fecha actual"
	^self costo: unVuelo aLaFecha: Date today tipo: unTipo.! !

!SistemaDeReservas methodsFor: 'operacion sobre tipoPasaje' stamp: 'LeandroGomez 6/11/2012 23:28'!
costoPorClase: unTipo
	^unTipo costoPorClase! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 13:16'!
datosHastaTag: aStream
	| datos |
	datos := ''.
	aStream next.
	[ aStream peek ~= $> ]
		whileTrue: [  datos := datos , aStream next asString].
	aStream next.
	^datos.! !

!SistemaDeReservas methodsFor: 'operacion sobre sistemaDeDescuento' stamp: 'LeandroGomez 6/16/2012 11:45'!
descuentoParaDia: unaFecha tipoPasaje: unTipo

	^self sistemaDeDescuento descuentoParaDia: unaFecha tipoPasaje: unTipo! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:30'!
destinoFinal: unVuelo
	^unVuelo destinoFinal! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:15'!
distanciaPromedio: unObjeto
	^unObjeto distanciaPromedio.! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:30'!
duracion: unVuelo
	^unVuelo duracion! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:56'!
esPasajero: unaPersona asiento: nroAsiento vuelo: unVuelo
	^unVuelo esPasajero: unaPersona asiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:32'!
esperaDespegue: unVuelo
	^unVuelo esperaDespegue ! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:33'!
estaCancelado: unVuelo
	^unVuelo estaCancelado! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:34'!
estaConfirmado: unVuelo
	^unVuelo estaConfirmado ! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 6/11/2012 22:34'!
estaConfirmado: nroAsiento vuelo:unVuelo
	^unVuelo estaConfirmado: nroAsiento ! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 6/11/2012 22:59'!
estaLibre: nroAsiento vuelo: unVuelo
	^unVuelo estaLibre: nroAsiento! !

!SistemaDeReservas methodsFor: 'operacion sobre pasajero' stamp: 'LeandroGomez 6/12/2012 15:44'!
estaPersona: unaPersona
	| nombre apellido fNacimiento nacionalidad |
	nombre := unaPersona nombre.
	apellido := unaPersona apellido.
	fNacimiento := unaPersona fnacimiento.
	nacionalidad := unaPersona nacionalidad.
	
	^self personas anySatisfy: [ :each  | (each nombre = nombre ) & (each apellido = apellido) &
										( each fNacimiento = fNacimiento) & 
										( each nacionalidad = nacionalidad ) ]! !

!SistemaDeReservas methodsFor: 'operacion sobre pasajero' stamp: 'LeandroGomez 6/30/2012 11:38'!
estaPersonaNombre: unNombre apellido: unApellido fnacimiento: unaFecha nacionalidad: unaNacionalidad
	^self personas anySatisfy: [ :each | (each nombre = unNombre) & (each apellido = unApellido) & 
										(each fnacimiento = unaFecha) & ( each nacionalidad  = unaNacionalidad ) ]! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 6/11/2012 22:23'!
estaReservado: nroAsiento vuelo: unVuelo
	^unVuelo estaReservado: nroAsiento.! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 6/30/2012 08:33'!
existeAvionDeLlamado: unNombre
	^self aviones anySatisfy: [ :each | each nombre = unNombre]! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/30/2012 08:39'!
existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha 

	^self vuelos anySatisfy: [ :each |  (each origen = unOrigen) & (each destino == unDestino) &
										(each fechaSalida == unaFecha)]! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/30/2012 08:39'!
existeVueloOrigen: unOrigen destino: unDestino avion: unAvion fechaSalida: unaFecha siguienteVuelo:  unVuelo

	^self vuelos anySatisfy: [ :each |  (each origen = unOrigen) & (each destino = unDestino) &
										(each fechaSalida = unaFecha) & (each siguienteVuelo  = unVuelo) ]! !

!SistemaDeReservas methodsFor: 'operacion sobre pasaje' stamp: 'LeandroGomez 6/23/2012 09:59'!
expender: unTipo persona: unaPersona vuelo: unVuelo asiento: nroAsiento
	|asiento|
	( self estaLibre: nroAsiento vuelo:  unVuelo)
			ifTrue: [ self asignar: unaPersona asiento: nroAsiento vuelo: unVuelo. 
					asiento := (Pasaje  newPersona: unaPersona 
												vuelo:  unVuelo nroAsiento: nroAsiento tipoPasaje: unTipo) .
					self agregarPasaje: asiento.
					asiento escribirEnDiscoEnPath: self folder.
					]
			ifFalse: [ self error: 'asiento Ocupado' ]! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 18:06'!
folder
	^ folder! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 18:06'!
folder: anObject
	folder := anObject! !

!SistemaDeReservas methodsFor: 'initialization' stamp: 'LeandroGomez 6/17/2012 13:20'!
initialize 
	self pasajes: SortedCollection new;
		vuelos: SortedCollection new;
		personas: SortedCollection new;
		sistemaDeDescuento: SinDescuentos new;
		aviones: OrderedCollection new.! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 6/30/2012 11:02'!
levantarBaseDeDatos
	self cargarAvionesDefault. 
	self cargarVuelosTrasnbordoDefault.
	self cargarVuelosInternacionalDefault.
	self cargarPersonasDefault.
	self cargarPasajerDefault.
				! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 6/12/2012 15:27'!
liberar: nroAsiento vuelo: unVuelo
	unVuelo liberar: nroAsiento! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 13:52'!
obtenerSiguienteVuelo: aStream
	| char origen destino destinoFinal avion fechaDespegueString estado siguienteVuelo vueloRet|
	[aStream atEnd] 
	whileFalse: [
		origen:= ''.
		destino := ''.
		destinoFinal := ''.
		avion := ''.
		fechaDespegueString := ''.
		"Cargar el origen"
		origen := self datosHastaTag: aStream.
		"Cargar el destino"
		destino := self datosHastaTag: aStream.
		"Cargar el destinoFinal"
		destinoFinal := self datosHastaTag: aStream.
		"Cargar avion"
		avion := self datosHastaTag: aStream.
		"Cargar fecha"
		fechaDespegueString := self datosHastaTag: aStream.
		"Cargar estado"
		estado := self datosHastaTag: aStream.
		"Cargo siguienteVuelo "
		( aStream peek = $<)
			ifTrue: [siguienteVuelo := self obtenerSiguienteVuelo: aStream.
					(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
								fechaSalida: fechaDespegueString asDate )
					ifFalse: [| vuelo | vuelo :=(Transbordo  newOrigen: origen destino: destino 
								avion: avion fechaDeSalida: fechaDespegueString asDate 
									siguienteVuelo: siguienteVuelo  ). 
					vuelo estado: estado.
					self vuelos add: vuelo.
					vueloRet:= vuelo.
							].
				]
			ifFalse: [(self existeVueloOrigen: origen destino: destino avion: (self avionLlamado: avion) 
					fechaSalida: fechaDespegueString asDate )
					ifFalse: [| vuelo | vuelo :=(Internacional newOrigen: origen destino: destino 
					avion: (self avionLlamado: avion) fechaDeSalida: fechaDespegueString asDate). 
					vuelo estado: estado.
					self vuelos add: vuelo.
					vueloRet:= vuelo.
							].
				].
			"Ignoro los Caracteres hasta la siguiente linea"
			char := aStream next
		].
	^vueloRet.! !

!SistemaDeReservas methodsFor: 'operacion sobre asiento' stamp: 'LeandroGomez 6/11/2012 22:36'!
pasajeroDelAsiento: nroAsiento vuelo: unVuelo
	^unVuelo pasajeroDelAsiento: nroAsiento! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes
	^ pasajes! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
pasajes: anObject
	pasajes := anObject! !

!SistemaDeReservas methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/30/2012 09:32'!
personaNombre: unNombre apellido: unApellido fnacimiento: unaFecha
	self personas detect: [:persona | (persona nombre = unNombre) & (persona apellido = unApellido)
										& (persona fnacimiento = unaFecha)] ifNone: [self error: 'No existe persona']! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas
	^ personas! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
personas: anObject
	personas := anObject! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:25'!
reprogramar: unaFecha avion: unAvion vuelo: unVuelo
	unVuelo reprogramar: unaFecha avion: unAvion! !

!SistemaDeReservas methodsFor: 'operacion sobre vuelo' stamp: 'LeandroGomez 6/11/2012 22:24'!
reprogramar: unaFecha vuelo: unVuelo
	unVuelo reprogramar: unaFecha! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 6/30/2012 11:12'!
sincronizarAviones
	(FileStream forceNewFileNamed: self folder , '\aviones.txt') close.
	self aviones do: [ :avion | avion escribirEnDiscoEnPath: self folder]
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 6/30/2012 11:26'!
sincronizarPersonas
	(FileStream forceNewFileNamed: self folder , '\personas.txt') close.
	self personas do: [ :persona | persona escribirEnDiscoEnPath: self folder]
		! !

!SistemaDeReservas methodsFor: 'Base de datos' stamp: 'LeandroGomez 7/1/2012 13:46'!
sincronizarVuelos
	| vuelosInter |
	(FileStream forceNewFileNamed: self folder , '\vuelos-Internacional.txt') close.
	(FileStream forceNewFileNamed: self folder , '\vuelos-Transbordos.txt') close.
	self vuelos do: [ :vuelo | vuelo escribirEnDiscoEnPath: self folder]
		! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 11:46'!
sistemaDeDescuento
	^ sistemaDeDescuento! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/16/2012 11:46'!
sistemaDeDescuento: anObject
	sistemaDeDescuento := anObject! !

!SistemaDeReservas methodsFor: 'operacion sobre avion' stamp: 'LeandroGomez 6/11/2012 20:09'!
velocidadPromedio: unAvion
	^unAvion velocidadPromedio! !

!SistemaDeReservas methodsFor: 'operacion sobre pasajero' stamp: 'LeandroGomez 6/11/2012 22:39'!
viaja: unaPersona vuelo: unVuelo
	^unVuelo viaja: unaPersona
	! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroGomez 6/30/2012 09:05'!
vueloOrigen: unOrigen destinoFinal: unDestino fechaSalida: unaFecha
	^self vuelos detect: [:vuelo | (vuelo origen = unOrigen) & (vuelo destinoFinal = unDestino) &
									(vuelo fechaSalida = unaFecha) ] ifNone: [self error: 'No existe Vuelo'].! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos
	^ vuelos! !

!SistemaDeReservas methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
vuelos: anObject
	vuelos := anObject! !

Object subclass: #TipoAvion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

TipoAvion subclass: #TipoComercial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!TipoComercial methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 09:42'!
cantidadDeAsientos
	^200.! !

!TipoComercial methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 10:36'!
printOn: aStream
	aStream nextPutAll: 'Comercial'.! !

!TipoComercial methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 09:41'!
velocidadPromedio
	^800.! !

TipoAvion subclass: #TipoJet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!TipoJet methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 09:41'!
cantidadDeAsientos
	^60.! !

!TipoJet methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 10:36'!
printOn: aStream
	aStream nextPutAll: 'Jet'.! !

!TipoJet methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/23/2012 09:41'!
velocidadPromedio
	^1200.! !

Object subclass: #TipoPasaje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

TipoPasaje subclass: #Business
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Business methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^0.75! !

!Business methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 11:04'!
printOn: aStream
	aStream nextPutAll: 'Bussiness'.! !

TipoPasaje subclass: #Economica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Economica methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^0.5! !

!Economica methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 11:04'!
printOn: aStream
	aStream nextPutAll: 'Economico'.! !

TipoPasaje subclass: #Primera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Primera methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:29'!
costoPorClase
	^1.! !

!Primera methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 11:04'!
printOn: aStream
	aStream nextPutAll: 'Primera'.! !

!TipoPasaje methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 10:42'!
= otroTipoPasaje
	^self costoPorClase = otroTipoPasaje costoPorClase.! !

!TipoPasaje methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/16/2012 21:14'!
costoPorClase
	self subclassResponsibility.! !

Object subclass: #Vuelo
	instanceVariableNames: 'origen destino avion fechaSalida estado asientos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

Vuelo subclass: #Internacional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Internacional methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 00:33'!
distanciaPromedio
	^2000.! !

!Internacional methodsFor: 'wirting' stamp: 'LeandroGomez 6/30/2012 09:59'!
escribirEnDiscoEnPath: unPath
	| aStream asientosOcupados|
	aStream := FileStream fileNamed: unPath , '\vuelos-Internacional.txt'.
	aStream setToEnd.
	aStream nextPutAll: self tags;
			 nextPut: Character cr;
			 close.! !

!Internacional methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/30/2012 08:50'!
siguienteVuelo
	^nil! !

!Internacional methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/30/2012 11:58'!
tags
	^'<', self origen,'><', self destino, '><', self destinoFinal , '><' , self avion nombre , '><', self fechaSalida asString , '><' , self estado, '>'.! !

Vuelo subclass: #Transbordo
	instanceVariableNames: 'siguienteVuelo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Aeropuerto-Logic'!

!Transbordo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:55'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha 
	self error: 'Para un vuelo transbordo se necesita otro vuelo internacional/transbordo'! !

!Transbordo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/10/2012 14:46'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha siguienteVuelo: otroVuelo

	|transbordo|
	transbordo := super newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha.
	transbordo siguienteVuelo: otroVuelo.
	^transbordo.! !

!Transbordo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 01:03'!
destinoFinal
	^self siguienteVuelo destinoFinal.! !

!Transbordo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 00:34'!
distanciaPromedio
	^2000 + (self siguienteVuelo distanciaPromedio).! !

!Transbordo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:55'!
duracion
	^ super duracion + self siguienteVuelo duracion.! !

!Transbordo methodsFor: 'wirting' stamp: 'LeandroGomez 6/30/2012 09:59'!
escribirEnDiscoEnPath: unPath
	| aStream asientosOcupados|
	aStream := FileStream fileNamed: unPath , '\vuelos-Transbordos.txt'.
	aStream setToEnd.
	aStream nextPutAll: self tags;
			 nextPut: Character cr;
			 close.
			
		
	





! !

!Transbordo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 22:03'!
siguienteVuelo
	^ siguienteVuelo! !

!Transbordo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 22:03'!
siguienteVuelo: anObject
	siguienteVuelo := anObject! !

!Transbordo methodsFor: 'operations' stamp: 'LeandroGomez 7/1/2012 13:36'!
tags
	^'<', self origen,'><', self destino, '><', self destinoFinal , '><' , self avion nombre ,'><' ,self fechaSalida asString  ,  '><' , self estado, '>', self siguienteVuelo tags.! !

!Vuelo class methodsFor: 'as yet unclassified' stamp: 'LeandroGomez 6/11/2012 19:51'!
newOrigen: unOrigen destino: unDestino avion: unAvion fechaDeSalida: unaFecha
	|vuelo|
	vuelo := super new.
	vuelo origen: unOrigen;
		   destino: unDestino;
		   avion: unAvion;
		   fechaSalida: unaFecha;
		   asientos: OrderedCollection new.
		   1 to: unAvion cantidadDeAsientos do: [ :nro | vuelo asientos add: 
															(AsientoDeAvion newNumero: nro)].
	 ^vuelo.
	! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/11/2012 18:12'!
< unVuelo
	^ self fechaSalida < unVuelo fechaSalida.! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/12/2012 15:00'!
<= unVuelo
	^ self fechaSalida <= unVuelo fechaSalida.! !

!Vuelo methodsFor: 'comparing' stamp: 'LeandroGomez 6/30/2012 08:26'!
= unVuelo
	^(self origen = unVuelo origen) & (self destinoFinal = unVuelo destinoFinal ) & 
			( self fechaSalida = unVuelo fechaSalida ) ! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 00:01'!
asientos
	^ asientos! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/11/2012 00:01'!
asientos: anObject
	asientos := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:03'!
asignar: unaPersona asiento: nro
	(nro <= self asientos size)
		ifTrue: [(self asientos detect: [ :asiento | asiento numero = nro] ) asignar: unaPersona.]
		ifFalse: [ self error: 'El asiento no existe']
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion
	^ avion! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
avion: anObject
	avion := anObject! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 08:26'!
cancelar
	self estado: 'Cancelado'.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:57'!
cantidadDeAsientos 
	^self avion cantidadDeAsientos.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:04'!
confirmar: nro
	| asiento|
	asiento := self asientos detect: [ :asient | asient numero = nro ].
	asiento estado: 'Confirmado'! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino
	^ destino! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
destino: anObject
	destino := anObject! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/10/2012 14:57'!
destinoFinal
	^ self destino.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 00:33'!
distanciaPromedio
	self subclassResponsibility.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:46'!
duracion
	^ self distanciaPromedio / self avion velocidadPromedio.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 20:04'!
esPasajero: unaPersona asiento: nroAsiento 
	|asiento|
	asiento := self asientos detect: [ :asient | asient numero = nroAsiento ].
	^asiento  esPasajero: unaPersona.! !

!Vuelo methodsFor: 'wirting' stamp: 'LeandroGomez 6/28/2012 12:35'!
escribirEnDiscoEnPath: unPath
	self subclassResponsibility.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:29'!
esperaDespegue 
	^self estado = 'Esperando despegue'.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:27'!
estaCancelado
	^self estado = 'Cancelado'! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:54'!
estaConfirmado: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) estaConfirmado.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:55'!
estaLibre: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) estaLibre.! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/9/2012 22:55'!
estaReservado: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) estaReservado.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado
	^ estado! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroGomez 6/9/2012 08:26'!
estado: anObject
	estado := anObject! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:49'!
fechaSalida
		^ fechaSalida
	! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:46'!
fechaSalida: anObject
	fechaSalida := anObject! !

!Vuelo methodsFor: 'initialization' stamp: 'LeandroGomez 6/9/2012 11:23'!
initialize 
	self estado: 'Esperando despegue'.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/9/2012 22:55'!
liberar: nroAsiento
	^(self asientos detect: [ :asient | asient numero = nroAsiento ]) liberar.! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen
	^ origen! !

!Vuelo methodsFor: 'accessing' stamp: 'LeandroJulianGomezVelazquez 6/5/2012 23:05'!
origen: anObject
	origen := anObject! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 00:18'!
pasajeroDelAsiento: nroAsiento

	^(self asientos detect: [ :asiento | asiento numero = nroAsiento]) persona! !

!Vuelo methodsFor: 'printing' stamp: 'LeandroGomez 6/23/2012 11:51'!
printOn: aStream
	"Definir el stream"
	aStream nextPutAll: 'Vuelo desde: ', self origen, ' hasta ', self destinoFinal , 
						'. fecha de despegue: ', self fechaSalida asString, ' ', self estado.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:04'!
reprogramar: unaFecha 
	self reprogramar: unaFecha avion: self avion.! !

!Vuelo methodsFor: 'operations' stamp: 'LeandroGomez 6/11/2012 20:04'!
reprogramar: unaFecha avion: unAvion
	(self asientos size < unAvion cantidadDeAsientos)
		ifTrue: [ self error: 'Debe ser un acion con la misma cantidad de asientos']
		ifFalse: [self fechaSalida: unaFecha.
				self estado: 'Reprogramado'.
				self avion: unAvion.]
	! !

!Vuelo methodsFor: 'questions' stamp: 'LeandroGomez 6/11/2012 20:05'!
viaja: unaPersona
	^self asientos anySatisfy: [ :asiento | asiento persona == unaPersona ].! !
